#include <sourcemod>
#include <sdkhooks>
#include <cstrike>
#include <shop>

#pragma semicolon 1
#define CATEGORY "weapon_colors"

public Plugin myinfo = {
    name        = "[SHOP] Weapon Colors",
    author      = "Ganter1234",
    version     = "1.0"
};

int g_iClientColor[MAXPLAYERS +1][4];
bool g_bWColors[MAXPLAYERS +1];
KeyValues g_hKv;

public void OnPluginStart()
{
    if (Shop_IsStarted()) Shop_Started();
}

public void OnPluginEnd()
{
    Shop_UnregisterMe();
}

public void OnMapStart()
{
    char buffer[PLATFORM_MAX_PATH];
    if (g_hKv != null) g_hKv.Close();
    g_hKv = new KeyValues("Weapon_Colors");
    
    Shop_GetCfgFile(buffer, sizeof(buffer), "weapon_colors.txt");
    
    if (!g_hKv.ImportFromFile(buffer)) SetFailState("Couldn't parse file %s", buffer);
}

public Shop_Started()
{
    if (g_hKv == null) OnMapStart();
    g_hKv.Rewind();
    char cName[80]; char cDescription[80];
    g_hKv.GetString("name", cName, sizeof(cName), "Weapon Colors");
    g_hKv.GetString("description", cDescription, sizeof(cDescription));
    
    CategoryId category_id = Shop_RegisterCategory(CATEGORY, cName, cDescription);
    
    g_hKv.Rewind();
    
    if (g_hKv.GotoFirstSubKey(true))
    {
        do
        {
            if (g_hKv.GetSectionName(cName, sizeof(cName)) && Shop_StartItem(category_id, cName))
            {
                g_hKv.GetString("name", cName, sizeof(cName), cName);
                g_hKv.GetString("description", cDescription, sizeof(cDescription), "");
                Shop_SetInfo(cName, cDescription, g_hKv.GetNum("price", 1000), g_hKv.GetNum("sellprice", -1), Item_Togglable, g_hKv.GetNum("duration", 604800));
                Shop_SetCallbacks(_, OnEquipItem);
                Shop_EndItem();
            }
        } while (g_hKv.GotoNextKey(true));
    }
    g_hKv.Rewind();
}

public ShopAction OnEquipItem(int client, CategoryId category_id, const char[] category, ItemId item_id, const char[] cItem, bool isOn, bool elapsed)
{
    if (isOn || elapsed)
    {
        g_bWColors[client] = false;
        
        return Shop_UseOff;
    }
    
    Shop_ToggleClientCategoryOff(client, category_id);
    
    if (g_hKv.JumpToKey(cItem, false))
    {
        g_bWColors[client] = true;

        int iColor[4];
        g_hKv.GetColor("color", iColor[0], iColor[1], iColor[2], iColor[3]);
        g_hKv.Rewind();
        
        for (int i = 0; i < 4; i++)
            g_iClientColor[client][i] = iColor[i];

        return Shop_UseOn;
    }
    
    PrintToChat(client, "\x01[\x03Shop\x01] \x01Не удалось активировать цвет оружия.");
    return Shop_Raw;
}

public OnClientPutInServer(client)
{
    SDKHook(client, SDKHook_WeaponCanUse, WeaponColors_WeaponCanUse);
}

public Action:CS_OnCSWeaponDrop(client, weapon)
{
    SetEntityRenderColor(weapon, 255, 255, 255, 255);
    return Plugin_Continue;
}

public Action:WeaponColors_WeaponCanUse(client, weapon)
{
    new Handle:data = CreateDataPack();
    WritePackCell(data, GetClientUserId(client));
    WritePackCell(data, weapon);
    ResetPack(data);
    
    if(g_bWColors[client])
    {
        CreateTimer(0.0, Timer_ColorWeapon, data);
    }

    return Plugin_Continue;
}

public Action:Timer_ColorWeapon(Handle:timer, any:data)
{
    new userid = ReadPackCell(data);
    new weapon = ReadPackCell(data);
    CloseHandle(data);

    new client = GetClientOfUserId(userid);
    
    if(!client || !IsValidEdict(weapon))
        return Plugin_Stop;

    SetEntityRenderMode(weapon, RENDER_TRANSCOLOR);
    SetEntityRenderColor(weapon, g_iClientColor[client][0], g_iClientColor[client][1], g_iClientColor[client][2], g_iClientColor[client][3]);

    return Plugin_Stop;
}